(in-package clotp)

; doesn't depend on weblocks, just hunchentoot

(defparameter *urls* '("https://a.totp.me:8443/prot"
                       "https://b1.totp.me:18443/prot2"
                       "https://b2.totp.me:28443/prot2"
                       "https://b3.totp.me:38443/prot2"
                       "https://b4.totp.me:48443/prot2"))

(defun fetch (urls action key arg)
  (if (null urls)
    (error "could not connect to any servers")
    (multiple-value-bind (x y)
                         (ignore-errors
                           (http-request (car urls)
                                         :parameters
                                         (list (cons "action" action)
                                               (cons "key"    key)
                                               (cons "arg"    arg))))
      (if (or (null x) (/= 200 y))
        (fetch (cdr urls) action key arg)
        x))))
(defun make-client-msg (key call2)
  (fetch *urls* "make-client-msg" key (encode-json-to-string call2)))
(defun decode-server-msg (key msg sid)
  (let ((sid2 (if (null sid) 0 (parse-integer sid))))
    (decode-json-from-string
      (fetch (subseq *urls* sid2 (1+ sid2)) "decode-server-msg" key msg))))

;;;;
(defparameter *reqs* 'outstanding-reqs)
(defun push-outstanding-request (oreq)
  (push oreq (hunchentoot:session-value *reqs*)))
(defun remove-outstanding-request (reqid)
  (prog1
    (find reqid (hunchentoot:session-value *reqs*) :key #'car)
    (setf (hunchentoot:session-value *reqs*)
          (remove reqid (hunchentoot:session-value *reqs*) :key #'car))))
(defvar *next-id* (make-counter))
(defvar *key* nil)
(defun call1 (fn u h)
  (let ((reqid (funcall *next-id*)))
    (push-outstanding-request (list reqid u h))
    (make-client-msg *key* (list reqid fn u))))
(aliasfn 'prov (curry 'call1 "prov"))
(aliasfn 'auth (curry 'call1 "auth"))

;;;;
(defun otp-response-handler (res sid)
  (let* ((res2 (decode-server-msg *key* res sid))
         (oreq (remove-outstanding-request (car res2))))
    (funcall (caddr oreq) (cadr oreq) (cadr res2))))
