(in-package clotp)

;to run this example
;set *key*
;configure app in web service to return control to otp-response handler
;http://localhost:8080/example/

(defun assert-authed ()
  (unless (webapp-session-value 'authed)
    (error "not logged in")))
(defun logged-in (k)
  (assert-authed)
  (with-html
    (fmt "you are logged in as ~A" (webapp-session-value 'authed)) (:br)
    (render-link (lambda/cc (&rest a) 
                   (redirect (prov (webapp-session-value 'authed)
                                   (let ((w (current-webapp)))
                                     (lambda (u nil-result)
                                       (make-webapp-uri "/" w))))
                     :defer :post-action))
                 "change totp")
    (:br)
    (render-answer k "logout")))
(defun example-app ()
  (render-link (lambda/cc (&rest a)
                 (redirect
                   (auth 
                     (car (req-list2 nil "userid"))
                     (let ((w (current-webapp)))
                       (lambda (u result)
                         (setf (webapp-session-value 'authed
                                                     hunchentoot:*session* w)
                               (if result u))
                         (make-webapp-uri "/" w))))
                   :defer :post-action)
                 (do-page #'logged-in))
               "login"))
(defun init-user-session (comp)
  (setf (composite-widgets comp) (list #'example-app)))
(defwebapp example :init-user-session 'init-user-session)

(hunchentoot:define-easy-handler (otp-response :uri "/otp-response") (res sid)
  (hunchentoot:redirect (otp-response-handler res sid)))

(setf *key* "J-yT29wUICq0f4WwgFz3cK8FKZb04X12_tVdtLi69So.")
