(in-package clotp)
;everything here is taken from my other libraries

;pg
(defun curry (fn &rest args)
  #'(lambda (&rest args2)
      (apply fn (append args args2))))
(defun rcurry (fn &rest args)
  #'(lambda (&rest args2)
      (apply fn (append args2 args))));end pg

(defun map0-n (fn n)
  (mapa-b fn 0 n))
(defun map1-n (fn n)
  (mapa-b fn 1 n))
(defun mapa-b (fn a b &optional (step 1))
  (do ((i a (+ i step))
       (result nil))
      ((> i b) (nreverse result))
    (push (funcall fn i) result)))
;mine
(defun aliasfn (sym fn)
  (setf (symbol-function sym) fn))
(defun make-counter (&optional (start 0))
  (let ((id start) (lck (make-lock)))
    ;later can hand out blocks of ids at a time
    ;need to wrap around at largest db long
    (lambda () (with-lock-held (lck) (incf id)))))
(defun render-answer (k text &rest render-link-args)
  (apply #'render-link (lambda (&rest args) (answer k)) text render-link-args))
;end mine
;axiom
(defun form-list (handler &rest field-names)
  (with-html-form (:POST
                   (lambda (&rest args)
                     (apply handler
                            (mapcar (rcurry #'nth args)
                                    (map1-n (lambda (i) (1- (* 2 i)))
                                            (length field-names)))))
                     :use-ajax-p nil)
    (:table
      (mapcar (lambda (x)
                (with-html
                  (:tr
                    (:td (fmt "~A:" x))
                    (:td (:input :type "text" :name x)))))
              field-names))
    (:input :type "submit" :value "submit")))

(defun req-list (&rest field-names)
  (lambda (k)
    (apply #'form-list (lambda (&rest args2) (answer k args2)) field-names)))
(defun/cc req-list2 (comp &rest field-names)
  (do-widget comp (make-widget (apply #'req-list field-names))))
;end axiom
